package com.jh.boot.attachment;

import java.io.InputStream;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;


public abstract class AbstractHibernateAttachmentService implements AttachmentService {

	private AttachmentRepository repository;
	
	@Override
	public Attachment saveAttachment(Attachment attachment, InputStream content) {
		saveAttachment(attachment);
		saveData(attachment, content);
		return attachment;
	}

	protected abstract void saveData(Attachment attachment, InputStream stream);
	
	
	@Override
	public Attachment saveAttachment(Attachment attachment) {
		repository.save(attachment);
		return attachment;
	}

	@Override
	public List<Attachment> fetchAttachments(Long unitId, String objectType, Long objectId) {
		return repository.findForUnitIdAndObject(unitId, objectType, objectId);
	}

	@Override
	public Attachment fetchAttachment(Long attachmentId) {
		return repository.findById(attachmentId);
	}


	@Override
	public void deleteAttachment(Long attachmentId) {
		throw new UnsupportedOperationException("Not implemented");
	}

	
	@Autowired(required = false)
	public void setRepository(AttachmentRepository repository) {
		this.repository = repository;
	}

}
