package com.jh.boot.attachment;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import com.jh.boot.jpa.AbstractIdEntity;


/**
 * The Class Attachment.
 */
@Entity
@Table(name = "ATTACHMENT")
public class Attachment extends AbstractIdEntity {

	/** The unit id. */
	@Column(name = "UNIT_ID")
	private Long unitId;
	
	/** The object type. */
	@Column(name = "OBJECT_TYPE")
	private String objectType;
	
	/** The object id. */
	@Column(name = "OBJECT_ID")
	private Long objectId;
	
	/** The name. */
	private String name;
	
	/** The mime type. */
	@Column(name = "MIME_TYPE")
	private String mimeType;
	
	/** The size. */
	@Column(name = "SIZE")
	private Long size;
	
	/** The filename. */
	@Column(name = "FILENAME")
	private String filename;
	
	/** The uploaded. */
	@Column(name = "UPLOADED")
	private Date uploaded;
	
	
	/**
	 * Gets the unit id.
	 *
	 * @return the unit id
	 */
	public Long getUnitId() {
		return unitId;
	}
	
	/**
	 * Sets the unit id.
	 *
	 * @param unitId the new unit id
	 */
	public void setUnitId(Long unitId) {
		this.unitId = unitId;
	}
	
	/**
	 * Gets the object type.
	 *
	 * @return the object type
	 */
	public String getObjectType() {
		return objectType;
	}
	
	/**
	 * Sets the object type.
	 *
	 * @param objectType the new object type
	 */
	public void setObjectType(String objectType) {
		this.objectType = objectType;
	}
	
	/**
	 * Gets the object id.
	 *
	 * @return the object id
	 */
	public Long getObjectId() {
		return objectId;
	}
	
	/**
	 * Sets the object id.
	 *
	 * @param objectId the new object id
	 */
	public void setObjectId(Long objectId) {
		this.objectId = objectId;
	}
	
	/**
	 * Gets the name.
	 *
	 * @return the name
	 */
	public String getName() {
		return name;
	}
	
	/**
	 * Sets the name.
	 *
	 * @param name the new name
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	/**
	 * Gets the mime type.
	 *
	 * @return the mime type
	 */
	public String getMimeType() {
		return mimeType;
	}
	
	/**
	 * Sets the mime type.
	 *
	 * @param mimeType the new mime type
	 */
	public void setMimeType(String mimeType) {
		this.mimeType = mimeType;
	}
	
	/**
	 * Gets the size.
	 *
	 * @return the size
	 */
	public Long getSize() {
		return size;
	}
	
	/**
	 * Sets the size.
	 *
	 * @param size the new size
	 */
	public void setSize(Long size) {
		this.size = size;
	}
	
	/**
	 * Gets the filename.
	 *
	 * @return the filename
	 */
	public String getFilename() {
		return filename;
	}
	
	/**
	 * Sets the filename.
	 *
	 * @param filename the new filename
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}
    
    /**
     * Gets the uploaded.
     *
     * @return the uploaded
     */
    public Date getUploaded() {
        return uploaded;
    }
    
    /**
     * Sets the uploaded.
     *
     * @param uploaded the new uploaded
     */
    public void setUploaded(Date uploaded) {
        this.uploaded = uploaded;
    }
	
}
