package com.jh.boot.attachment.api;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.ResponseBody;

import com.jh.boot.attachment.Attachment;
import com.jh.boot.attachment.AttachmentService;

@Controller
@ConditionalOnBean(AttachmentService.class)
public class AttachmentApiController {
	
	@Autowired
	private AttachmentService service;

	
	@GetMapping("/attachments/{unitId}/{objectType}/{objectId}")
	public @ResponseBody List<Attachment> listAttachments(@PathVariable("unitId") Long unitId, @PathVariable("objectType") String objectType, @PathVariable("objectId") Long objectId) {
		return service.fetchAttachments(unitId, objectType, objectId);
	}
	
	
	
}
