package com.jh.boot.security;

import java.util.Set;
import java.util.stream.Collectors;

import org.springframework.security.core.Authentication;

import com.jh.boot.security.model.AppRole;
import com.jh.boot.security.model.AppUser;

public class SecurityHelper {

	public static final String ADMIN_ROLE = "ROLE_ADMIM";
	
	private SecurityHelper() {
	}

	public boolean hasAnyRole(Authentication auth, String...roles) {
		AppUser user = auth instanceof AppUserAuthentication ? ((AppUserAuthentication) auth).getUser() : null;
		
		if (user == null || user.getRoles() == null || roles == null || roles.length == 0) {
			return false;
		}
		
		Set<String> set = user.getRoles().stream().map(AppRole::getName).collect(Collectors.toSet());
		if (set.contains(ADMIN_ROLE)) {
			return true;
		}
		
		for (String role : roles) { 
			if (set.contains(role)) {
				return true;
			}
		}
		
		return false;
	}
	
	
}
